<?php
/************************************************************************
 * This file is part of EspoCRM.
 *
 * EspoCRM - Open Source CRM application.
 * Copyright (C) 2014  Yuri Kuznetsov, Taras Machyshyn, Oleksiy Avramenko
 * Website: http://www.espocrm.com
 *
 * EspoCRM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EspoCRM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EspoCRM. If not, see http://www.gnu.org/licenses/.
 ************************************************************************/

class AfterUpgrade
{
    public function run($container)
    {
        $config = $container->get('config');

        $languageList = $config->get('languageList', []);

        if (!in_array('en_GB', $languageList)) {
            $languageList[] = 'en_GB';
        }
        if (!in_array('es_MX', $languageList)) {
            $languageList[] = 'es_MX';
        }
        if (!in_array('sr_RS', $languageList)) {
            $languageList[] = 'sr_RS';
        }
        $config->set('languageList', $languageList);

        $config->save();

        $metadata = $container->get('metadata');

        $entityDefs = $metadata->get(['entityDefs']);
        $isMet = false;
        foreach ($entityDefs as $scope => $defs) {
            $fieldDefs = $metadata->get(['entityDefs', $scope, 'fields'], array());
            foreach ($fieldDefs as $field => $item) {
                if (!empty($item['type'])) {
                    if (in_array($item['type'], ['file', 'image']) && !empty($item['skipOrmDefs'])) {
                        $isMet = true;
                        $metadata->delete('entityDefs', $scope, ['fields.'.$field.'.skipOrmDefs']);
                    }
                }
            }
        }
        if ($isMet) {
            $metadata->save();
        }
    }
}
